 include/asm-mips64/bitops.h |   36 +++++++++++++++++-------------------
 1 files changed, 17 insertions(+), 19 deletions(-)

diff -puN include/asm-mips64/bitops.h~ext2-no-lock_super-fix-4 include/asm-mips64/bitops.h
--- 25/include/asm-mips64/bitops.h~ext2-no-lock_super-fix-4	2003-03-13 23:51:05.000000000 -0800
+++ 25-akpm/include/asm-mips64/bitops.h	2003-03-13 23:51:47.000000000 -0800
@@ -516,16 +516,6 @@ ext2_set_bit(int nr,void * addr)
 	return retval;
 }
 
-static inline int
-ext2_set_bit_atomic(spinlock_t * lock, int nr, void * addr)
-{
-        int ret;
-        spin_lock(lock);
-        ret = ext2_set_bit(nr, addr);
-        spin_unlock(lock);
-        return ret;
-}
-
 extern inline int
 ext2_clear_bit(int nr, void * addr)
 {
@@ -541,15 +531,23 @@ ext2_clear_bit(int nr, void * addr)
 	return retval;
 }
 
-static inline int
-ext2_clear_bit_atomic(spinlock_t * lock, int nr, void * addr)
-{
-        int ret;
-        spin_lock(lock);
-        ret = ext2_clear_bit(nr, addr);
-        spin_unlock(lock);
-        return ret;
-}
+#define ext2_set_bit_atomic(lock, nr, addr)		\
+	({						\
+		int ret;				\
+		spin_lock(lock);			\
+		ret = ext2_set_bit((nr), (addr));	\
+		spin_unlock(lock);			\
+		ret;					\
+	})
+
+#define ext2_clear_bit_atomic(lock, nr, addr)		\
+	({						\
+		int ret;				\
+		spin_lock(lock);			\
+		ret = ext2_clear_bit((nr), (addr));	\
+		spin_unlock(lock);			\
+		ret;					\
+	})
 
 extern inline int
 ext2_test_bit(int nr, const void * addr)

_
